#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr, *work;
    int neval, ier, key, last, *iwork;

 // a and b are the integration limits
    a = 0.0;
    b = M_PI;    // M_PI is the constant for Pi (greek letter P)

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0;
    epsrel = 0.001;
 
 // key determines the integration rule used in c_dqag
    key = 6;

 // allocate memory
    iwork = (int *) calloc(LIMIT, sizeof(int));
    work = (double *) calloc(LENW, sizeof(double));
 
    result = cquad_dqag(fun, a, b, epsabs, epsrel, key, &abserr, &neval, &ier, &last, iwork, work);

 // print the result
    printf("\nFunction:  cos(100 * sin(x))  over [0, Pi]\n");
    printf("\nIntegral approximation:            %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iwork);
    free(work);
}
