#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr;
    double *points, *pts, *level, *alist, *blist, *rlist, *elist;
    int neval, ier, npts2, last, *iord, *ndin;

 // a and b are the integration limits
    a = 0.0;
    b = 3.0;

 // points[i], i = 0, ..., npts2 - 3 are the abscissae where a difficulty 
 // of the integrand is situated

    npts2 = 4;
    points = (double *) calloc(npts2, sizeof(double));
    points[0] = 1.0;
    points[1] = sqrt(2.0);

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0.0;
    epsrel = 0.001;

 // allocate memory
    iord = (int *) calloc(LIMIT, sizeof(int));
    ndin = (int *) calloc(npts2, sizeof(int));
    alist = (double *) calloc(LIMIT, sizeof(double));
    blist = (double *) calloc(LIMIT, sizeof(double));
    rlist = (double *) calloc(LIMIT, sizeof(double));
    elist = (double *) calloc(LIMIT, sizeof(double));
    pts = (double *) calloc(npts2, sizeof(double));
    level = (double *) calloc(LIMIT, sizeof(double));

    result = cquad_dqagpe(fun, a, b, npts2, points, epsabs, epsrel, &abserr, &neval, &ier, alist, blist, rlist, elist, pts, iord, level, ndin, &last);
 
 // print the result
    printf("\nFunction:  x³ * log|(x²-1)(x²-2)|  over [0, 3]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory
    free(points); 
    free(iord);
    free(alist);
    free(blist);
    free(rlist);
    free(elist);
    free(pts);
    free(ndin);
    free(level);
}
